package x36paa_batoh_dp_4;

import java.util.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class Heuristic1 extends MethodInterface {
  // Heuristika podle klesajc ceny
  public Heuristic1() {
  }

  public MethodInterface newInstance() {
    return new Heuristic1();
  }

  protected Output calc(Input in, int calcBy) {
    long time=System.nanoTime();
    List<Item> items=new LinkedList<Item>();
    for (Input i=in.iterator();i.hasNext();) {
      Item item=(Item) i.next();
      switch (calcBy) {
        case 1: // Heuristika podle klesajc ceny
          item.setH(item.getPrice());
          break;
        case 2: // Heuristika podle rostouc hmotnosti
          item.setH(-item.getWeigth());
          break;
        case 3: // Heuristika podle pomru cena/hmotnost
          item.setH(((double) item.getPrice())/((double) item.getWeigth()));
          break;
      }
      items.add(item);
    }
    Collections.sort(items);
    List<Item> out=new LinkedList<Item>();
    int weigth=0;
    Iterator it=items.iterator();
    while ((weigth<in.getMaxWeight()) && (it.hasNext())) {
      Item item=(Item) it.next();
      if (item.getWeigth()<=(in.getMaxWeight()-weigth)) {
        weigth+=item.getWeigth();
        out.add(item);
      }
    }
    return new Output(in, out,System.nanoTime()-time,in.size());
  }

  public Output calc(Input in) {
    return calc(in,1);
  }
}
