package x36paa_batoh_dp_4;

import java.util.Iterator;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class SelectedAlgorithmFactory implements Iterable, Iterator {

  private static boolean selected[]=new boolean[AlgorithmFactory.getCountOfAlgorithm()];
  private int position=-1;

  public static void setup(boolean selected[]) {
    for (int i=0;(i<selected.length) || (i<SelectedAlgorithmFactory.selected.length);i++) {
      SelectedAlgorithmFactory.selected[i]=selected[i];
    }
  }

  public static void set(int id, boolean state) {
    selected[id]=state;
  }

  public static boolean get(int id) {
    return selected[id];
  }

  public static int getCountOfAlgorithm() {
    int out=0;
    for (boolean b:selected) if (b) out++;
    return out;
  }

  public static int getParentId(int methodId) {
    int id=-1;
    for (int i=0;i<selected.length;i++) {
      if (selected[i]) {
        id++;
        if (id==methodId) return i;
      }
    }
    return id;
  }

  public static String getName(int methodId) {
    return AlgorithmFactory.getName(getParentId(methodId));
  }

  public static MethodInterface getMethod(int methodId) {
    return AlgorithmFactory.getMethod(getParentId(methodId));
  }

  public static Output doWith(Input input, int methodId) {
    return AlgorithmFactory.doWith(input,getParentId(methodId));
  }

  public Iterator iterator() {
    position=-1;
    return this;
  }

  public boolean hasNext() {
    return (position+1<getCountOfAlgorithm());
  }

  public Object next() {
    return getMethod(++position).newInstance();
  }

  public void remove() {
    throw new Error("Nelze mazat ve statickm poli.");
  }
}
