package x36paa_batoh_dp_4;

import java.util.Iterator;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class AlgorithmFactory implements Iterable, Iterator {

  private static final String[] name={
                                     "Brutln sla",
                                     "Heuristika podle klesajc ceny",
                                     "Heuristika podle rostouc hmotnosti",
                                     "Heuristika podle pomru cena/hmotnost",
                                     "Heuristika podle klesajc ceny (s testem)",
                                     "Heuristika podle rostouc hmotnosti (s testem)",
                                     "Heuristika podle pomru cena/hmotnost (s testem)",
                                     "Metoda vtv a hranic",
                                     "Dynamick programovn: s dopednou fz",
                                     "Dynamick programovn: bez dopedn fze",
                                     "Dynamick programovn: cena x vci"
  };

  private static final MethodInterface[] methods={
                                                 new BrutalForce(),
                                                 new Heuristic1(),
                                                 new Heuristic2(),
                                                 new Heuristic3(),
                                                 new Heuristic1Test(),
                                                 new Heuristic2Test(),
                                                 new Heuristic3Test(),
                                                 new MethodOfBranchsAndBorders(),
                                                 new DP1(),
                                                 new DP2(),
                                                 new DP3()
  };

  private int position;

  public static int getCountOfAlgorithm() {
    return methods.length;
  }

  public static String getName(int methodId) {
    return name[methodId];
  }

  public static MethodInterface getMethod(int methodId) {
    return methods[methodId].newInstance();
  }

  public static Output doWith(Input input, int methodId) {
    return getMethod(methodId).calc(input);
  }

  public Iterator iterator() {
    position=-1;
    return this;
  }

  public boolean hasNext() {
    return (position+1<methods.length);
  }

  public Object next() {
    return methods[++position].newInstance();
  }

  public void remove() {
    throw new Error("Nelze mazat ve statickm poli.");
  }

}
