package x36paa_batoh_dp_4;

import java.util.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class Graph {

  LinkedList<Value> data=new LinkedList();

  public Graph() {
  }

  public void sort() {
    Collections.sort(data);
  }

  public int size() {
    return data.size();
  }

  public int getId(int position) {
    return data.get(position).id;
  }

  private Value getValue(int id) {
    for (Value v:data) {
      if (v.id==id) return v;
    }
    return null;
  }

  public void add(int id, double value) {
    Value v=getValue(id);
    if (v==null) {
      data.add(new Value(id,value));
    } else v.add(value);
  }

  public void add(int id, double value, String name) {
    Value v=getValue(id);
    if (v==null) {
      data.add(v=new Value(id,value));
    } else v.add(value);
    v.setName(name);
  }

  public double getMax() {
    double out=Double.MIN_VALUE;
    for (Value v:data) {
      if (out<v.max) out=v.max;
    }
    return out;
  }

  public double getMaxAvg() {
    double out=Double.MIN_VALUE;
    for (Value v:data) {
      if (out<v.sum/v.count) out=v.sum/v.count;
    }
    return out;

  }

  public double getMax(int id) {
    Value v=getValue(id);
    return v==null?0.:v.max;
  }

  public double getAvg(int id) {
    Value v=getValue(id);
    return v==null?0.:(v.count>0?v.sum/v.count:0);
  }

  public String getHead() {
    StringBuffer out=new StringBuffer();
    out.append("\t");
    for (Value value : data) {
      out.append(value.getName() + "\t");
    }
    out.append("\n");
    return out.toString();
  }

  class Value implements Comparable {

    public double max=Double.MIN_VALUE, sum;
    public int count, id;
    public String name;

    public Value(int id, double value) {
      this.id=id;
      add(value);
    }

    public void add(double value) {
      sum+=value;
      if (max<value) max=value;
      count++;
    }
    public void setName(String name) {
      this.name=name;
    }

    public String getName() {
      return name;
    }

    public int compareTo(Object o) {
      return id-((Value) o).id;
    }
  }
}
