package x36paa_batoh_dp_4;

import javax.swing.*;
import layout.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class Main extends JFrame implements WindowListener, ActionListener, ItemListener {

  private SourceTable sourceTable=new SourceTable();
  private Graphs graphs=new Graphs();
  private JCheckBox checkbox[]={new JCheckBox("prbn pekreslovat",true),new JCheckBox("mka",true),new JCheckBox("npisy",true)};

  private int methodId=0;

  private JButton buttons[]={
                            new JButton(""),
                            new JButton("Vye zadanou lohu"),
                            new JButton("Prove men sloitosti (ve)"),
                            new JButton("Prove men sloitosti (bez BF a B&B)"),
                            new JButton("Prove men sloitosti (bez BF)"),
                            new JButton("Prove men na souborech"),
                            new JButton("Measure 2_1"),
                            new JButton("men dle parametr vpravo dole"),
  };

  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    } catch (Exception e) {
      e.printStackTrace();
    }
    new Main();
  }

  private void showAlgorithm() {
    buttons[0].setText("Algoritmus : " + AlgorithmFactory.getName(methodId));
  }

  public JPanel getButtonsPanel() {
    /*double size[][]=new double[2][];
    size[0]=new double[2*buttons.length-1];
    size[1]=new double[] {TableLayout.PREFERRED};
    for (int i=0;i<size[0].length;i++) size[0][i]=((i&1)==0)?TableLayout.PREFERRED:5;
    size[0][3]=TableLayout.FILL;
    JPanel out=new JPanel(new TableLayout(size));
    for (int i=0;i<buttons.length;i++) {
      buttons[i].addActionListener(this);
      out.add(buttons[i], (i*2)+",0,F,F");
    }*/
    JPanel out=new JPanel(new TableLayout(new double[][] {
                                          {TableLayout.PREFERRED,TableLayout.FILL,TableLayout.PREFERRED,TableLayout.FILL,TableLayout.PREFERRED,TableLayout.FILL,TableLayout.PREFERRED},
                                          {TableLayout.PREFERRED,5,TableLayout.PREFERRED}
    }));
    for (int i=0;i<8;i++) {
      out.add(buttons[i],(2*(i%4))+","+(2*(i/4))+",F,F");
      buttons[i].addActionListener(this);
    }
    showAlgorithm();
    return out;
  }

  public void actionPerformed(ActionEvent event) {
    int idButton=-1;
    Object src=event.getSource();
    for (int i=0;i<buttons.length;i++) if (src.equals(buttons[i])) idButton=i;
    switch (idButton) {
      case 0: // Algoritmus : X
        if (++methodId>=AlgorithmFactory.getCountOfAlgorithm()) methodId=0;
        showAlgorithm();
        break;
      case 1: // Vye zadanou lohu
        Output output=AlgorithmFactory.getMethod(methodId).calc(sourceTable.getData());
        JDialog jDialog=new JDialog(this,"een",true);
        jDialog.getContentPane().add(new JTextArea("Metoda :"+AlgorithmFactory.getName(methodId)+"\n"+output.getVectorString() + "\nBatoh obsahuje:" +output.getInsertedItemsString()));
        jDialog.pack();
        jDialog.setLocationRelativeTo(this);
        jDialog.setVisible(true);
        break;
      case 2: // Prove men sloitosti (s BF)
        graphs.setMeasure(new Measure1());
        break;
      case 3: // Prove men sloitosti (bez BF a BB)
        graphs.setMeasure(new Measure2());
        break;
      case 4: // Prove men sloitosti (bez BF)
        graphs.setMeasure(new Measure3());
        break;
      case 5: // Prove men na souborech
        new FilesTester();
        break;
      case 6: // measure2_1
        graphs.setMeasure(new Measure2_1(10,0,300,0));
        break;
      case 7: // mereni podle parametru vpravo dole

        int i=0;
        for (JCheckBox jcb:checks) {
          SelectedAlgorithmFactory.set(i++,jcb.isSelected());
        }
        if (SelectedAlgorithmFactory.getCountOfAlgorithm()<=0) break;
        int j=0;
        i=0;
        for (JRadioButton jrb:checks2) {
          if (jrb.isSelected()) j=i;
          i++;
        }
        int k=0;
        i=0;
        for (JRadioButton jrb:checks3) {
          if (jrb.isSelected()) k=i;
          i++;
        }
        graphs.setMeasure(new Measure4(j,k,Integer.parseInt(count.getText())));
        break;
      default:
        assert false;
    }
  }

  JCheckBox checks[]=new JCheckBox[AlgorithmFactory.getCountOfAlgorithm()];
  String names[]={"velikost instance","maximln hmotnost Wmax","maximln cena Cmax","pomr m","granularita"};
  JTextField count=new JTextField("30");
  JRadioButton checks2[]=new JRadioButton[names.length];
  ButtonGroup kindMeasure=new ButtonGroup();

  ButtonGroup subject=new ButtonGroup();
  JRadioButton checks3[]=new JRadioButton[3];

  public JPanel getExtraMeasurePanel() {
    double size[][]=new double[2][];
    size[0]=new double[] {300,50,10,150,50};
    size[1]=new double[AlgorithmFactory.getCountOfAlgorithm()+1];
    for (int i=0;i<size[1].length;i++) size[1][i]=TableLayout.PREFERRED;
    JPanel out=new JPanel(new TableLayout(size));
    out.add(new JLabel("<html><b>Metoda</b></html>"),"0,0,F,F");
    out.add(new JLabel("<html><b>pout</b></html>"),"1,0,F,F");
    out.add(new JLabel("<html><b>Zvislost</b></html>"),"3,0,F,F");
    for (int i=0;i<AlgorithmFactory.getCountOfAlgorithm();i++) {
      out.add(new JLabel("<html><b><i>"+AlgorithmFactory.getName(i)+"</i></b></html>"),"0,"+(i+1)+",F,F");
      out.add(checks[i]=new JCheckBox(),"1,"+(i+1)+",F,F");
    }
    for (int i=0;i<AlgorithmFactory.getCountOfAlgorithm()+1;i++) {
      out.add(new JLabel("<html><b>| </b></html>"), "2,"+i+",F,F");
    }

    out.add(new JLabel("<html><b><i>Instanc/men</i></b></html>"),"3,1,F,F");
    out.add(count,"4,1,F,F");

    for (int i=0;i<names.length;i++) {
      out.add(checks2[i]=new JRadioButton(),"4,"+(i+2)+",F,F");
      kindMeasure.add(checks2[i]);
      out.add(new JLabel("<html><b><i>" + names[i] + "</i></b></html>"),"3,"+(i+2)+",F,F");
    }

    String texts[]={"<html><b>Kvalita</b></html>","<html><b><i>as</i></b></html>","<html><b><i>poet operac</i></b></html>","<html><b><i>rel. odchylka</i></b></html>"};
    for (int i=0;i<4;i++) {
      out.add(new JLabel(texts[3-i]),"3,"+(AlgorithmFactory.getCountOfAlgorithm()-i)+",F,F");
    }
    for (int i=0;i<3;i++) {
      subject.add(checks3[2-i]=new JRadioButton());
      out.add(checks3[2-i],"4,"+(AlgorithmFactory.getCountOfAlgorithm()-i)+",F,F");
    }
    checks2[0].setSelected(true);
    checks3[0].setSelected(true);
    return out;
  }

  public Main() {
    super("Problm batohu");

    JPanel jpanel=new JPanel(new TableLayout(new double[][] {
        {300,TableLayout.FILL,TableLayout.PREFERRED,TableLayout.PREFERRED,TableLayout.PREFERRED},
        {TableLayout.FILL,TableLayout.PREFERRED,TableLayout.PREFERRED,TableLayout.PREFERRED}
    })) /*{
      int width;
      public void doLayout() {
        Object parent=this.getParent();
        JViewport jvp=(JViewport) parent;
        int w=jvp.getWidth();
        if (w!=width) {
          width=w;
          this.repaint();
        }
        super.doLayout();
        System.out.print(".");
      }
    }*/;

    jpanel.add(sourceTable,"0,0,0,2");
    jpanel.add(graphs,"1,0,4,0");

    jpanel.add(checkbox[0],"2,1,F,F");
    jpanel.add(checkbox[1],"3,1,F,F");
    jpanel.add(checkbox[2],"4,1,F,F");

    jpanel.add(getExtraMeasurePanel(),"1,2,4,2");

    jpanel.add(getButtonsPanel(),"0,3,4,3");

    /*this.add(new JScrollPane(jpanel) {
      public void doLayout() {
        super.doLayout();
        for (java.awt.Component c:this.getViewport().getComponents()) c.doLayout();
//        this.getComponent(0).doLayout();
      }
    });*/this.add(jpanel);

    for (JCheckBox c:checkbox) c.addItemListener(this);
    this.addWindowListener(this);
    this.pack();
    this.setLocationRelativeTo(null);
    this.setVisible(true);
  }

  public void windowOpened(WindowEvent e) {
  }

  public void windowClosing(WindowEvent e) {
    System.exit(0);
  }

  public void windowClosed(WindowEvent e) {
  }

  public void windowIconified(WindowEvent e) {
  }

  public void windowDeiconified(WindowEvent e) {
  }

  public void windowActivated(WindowEvent e) {
  }

  public void windowDeactivated(WindowEvent e) {
  }

  public void itemStateChanged(ItemEvent e) {
    graphs.setAutoRepaint(checkbox[0].isSelected());
    graphs.setGrid(checkbox[1].isSelected());
    graphs.setLabels(checkbox[2].isSelected());
    graphs.repaint();
  }
}
