package x36paa_batoh_dp_4;

import java.awt.Color;
import java.util.*;
import java.awt.Canvas;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class Measure1 implements MeasureInterface, Runnable {

  protected int COUNT=30, MAX=12;

  Thread timer;

  long times[][], opers[][];
  long count;

  Graphs canvas;

  protected int getCountOfAlgorithm() {
    return AlgorithmFactory.getCountOfAlgorithm();
  }

  protected MethodInterface getMethod(int i) {
    return AlgorithmFactory.getMethod(i);
  }

  protected String getName(int i) {
    return AlgorithmFactory.getName(i);
  }

  public Measure1() {
    go();
  }

  protected void go() {
    times=new long[MAX][getCountOfAlgorithm()];
    opers=new long[MAX][getCountOfAlgorithm()];
    timer=new Thread(this);
    timer.start();
  }

  public void stop() {
    if (timer==null) return;
    try {
      timer.stop();
    } catch(Exception e) {}
  }

  public void run() {
    Random rnd=new Random();
    for (int i=1;i<MAX;i++) {
      for (int j=0;j<COUNT;j++) {
        List<Item> items=new LinkedList<Item>();
        for (int k=0;k<i;k++) {
          int weigth=5+Math.abs(rnd.nextInt()%(125/i));
          int price=5+Math.abs(rnd.nextInt()%(125));
          Item item=new Item(price,weigth,"Vc . "+(k+1));
          items.add(item);
        }
        Input input=new Input(items,100);
        for (int k=0;k<getCountOfAlgorithm();k++) {
          Output output=getMethod(k).calc(input);
          times[i][k]+=output.getTime();
          opers[i][k]+=output.getCountOfOperations();
        }
      }
      if (canvas!=null) canvas.autoRepaint();
      try {
        timer.sleep(10);
      } catch (Exception e) {}
    }
    if (canvas!=null) canvas.repaint();
    System.out.println(toString());
  }

  public int getCountOfGraph() {
    return getCountOfAlgorithm();
  }

  public String getGraphName(int i) {
    return getName(i)+ "[0-" + Math.round(getGraphMaxValue()/(1000*COUNT)) + " us]";
  }

  public Color getGraphColor(int i) {
    return new Color[] {
        Color.RED,
        Color.BLUE,
        Color.GREEN,
        Color.YELLOW,

        Color.BLACK,
        Color.ORANGE,
        Color.PINK,
        Color.CYAN,

        Color.MAGENTA,
        Color.LIGHT_GRAY,
        Color.GRAY
    }[i];
  }

  public double getGraphMaxValue() {
    long out=0;
    for (int i=0;i<times.length;i++) {
      for (int j=0;j<times[i].length;j++) {
        long v=times[i][j];
        if (v>out) out=v;
      }
    }
    return out;
  }

  public double getGraphMaxValue(int i) {
    return getGraphMaxValue();
  }

  public int getGraphValuesCount() {
    return MAX;
  }

  public double getGraphValue(int graph, int position) {
//    if (times[position][graph]/getGraphMaxValue()>1.) System.out.println(times[position][graph]/getGraphMaxValue());
    return times[position][graph]/getGraphMaxValue();
  }

  public String toString() {
    String out="as\n";
    for (int i=0;i<getCountOfAlgorithm();i++)
      out+=getName(i)+" [ns]\t";
    out+="\n";
    for (int i=0;i<times.length;i++) {
      for (int j=0;j<times[i].length;j++) {
        out+=(times[i][j]/COUNT)+"\t";
      }
      out+="\n";
    }

    out+="Poet operac\n";

    for (int i=0;i<getCountOfAlgorithm();i++)
      out+=getName(i)+"\t";
    out+="\n";
    for (int i=0; i<opers.length; i++) {
      for (int j=0; j<opers[i].length; j++) {
        out+=(opers[i][j]/COUNT)+"\t";
      }
      out+="\n";
    }

    return out;
  }

  public void setCanvas(Graphs canvas) {
    this.canvas=canvas;
  }
}
