package x36paa_batoh_dp_4;

import java.awt.Color;
import java.util.*;
import java.awt.Canvas;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class Measure2_1 implements MeasureInterface, Runnable {

  int results[][];
  String name="Zavislost na ";

  Thread timer=new Thread(this);

  Graphs canvas;

  int count,from,to,by;
  public Measure2_1(int count,int from, int to, int by) {
    this.count=count;
    this.from=from;
    this.to=to;
    this.by=by;
    results=new int[AlgorithmFactory.getCountOfAlgorithm()][to-from+1];
    timer.start();
  }

  public void setCanvas(Graphs canvas) {
    this.canvas=canvas;
  }

  public void run() {
    int ints[]=      {5,0/*.6*/,100,250,1/*.*/,0};
    double doubles[]={5,0.6,100,250,1.,0};

    ints[by]+=from;
    doubles[by]+=from;

    for (int i=0;i<=to-from;i++) {
      List<Input> list=Generator.generate(count,ints[0],doubles[1],ints[2],ints[3],doubles[4],ints[5]);
      for (Input input:list) {
        for (int j=0;j<AlgorithmFactory.getCountOfAlgorithm();j++) {
          results[j][i]+=AlgorithmFactory.getMethod(j).calc(input).getCountOfOperations();
          try {
            timer.sleep(10);
          } catch (Exception e) {}
        }
        if (canvas!=null) canvas.autoRepaint();
      }
      ints[by]+=1;
      doubles[by]+=1;
    }
    if (canvas!=null) canvas.repaint();
  }

  public int getCountOfGraph() {
    return results.length;
  }

  public String getGraphName(int i) {
    return name+" : "+AlgorithmFactory.getName(i);
  }

  public Color getGraphColor(int i) {
    return new Color[] {
        Color.RED,
        Color.BLUE,
        Color.GREEN,
        Color.YELLOW,

        Color.BLACK,
        Color.ORANGE,
        Color.PINK,
        Color.CYAN,

        Color.MAGENTA,
        Color.LIGHT_GRAY,
        Color.GRAY
    }[i];
  }

  public double getGraphMaxValue(int id) {
    double max=0.;
    for (int i=0;i<results.length;i++)
      for (int j=0;j<results[i].length;j++)
        if (max<results[i][j]) max=results[i][j];
    return max;
  }

  public int getGraphValuesCount() {
    return results[0].length;
  }

  public double getGraphValue(int graph, int position) {
    return results[graph][position]/getGraphMaxValue(graph);
  }

  public void stop() {
    if (timer==null) return;
    try {
      timer.stop();
    } catch(Exception e) {}
  }

}
